<?php

/**
 * Back-end of Flexslider_XH.
 * Copyright (c) 2014 svasti@svasti.de
 */


if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

define('FLEXSLIDER_VERSION', '0.4.1');

/**
 * Plugin administration
 */
initvar('flexslider');
if ($flexslider) {
    initvar('admin');
    initvar('action');
    $plugin = basename(dirname(__FILE__),"/");
    $admin  = isset($_POST['admin']) ? $_POST['admin'] : $admin = isset($_GET['admin']) ? $_GET['admin'] : '';
    $action = isset($_POST['action']) ? $_POST['action'] : $action = isset($_GET['action']) ? $_GET['action'] : '';
    $hjs .= '<link rel="stylesheet" type="text/css" href="'.$pth['folder']['plugins'].$plugin.'/css/backend.css">';
    $o .= print_plugin_admin('on');


    // Preparation and reception of post data
    //=========================================

    include 'funcs.php';
    include 'parsedown/Parsedown.php';

    if(isset($_POST['activate'])) {
        activate();
        include $pth['folder']['plugins'] . $plugin . '/config/config.php';
    }

    // Get folder for flexslider image files
    $imagefile_pth = $plugin_cf[$plugin]['path_flexslider_data_files']
                  ? $plugin_cf[$plugin]['path_flexslider_data_files']
                  : $pth['folder']['userfiles'].'plugins/'.$plugin.'/';
    // Make folder if missing
    if (!is_dir($imagefile_pth)) {
        if(mkdir($imagefile_pth,0777,true)===false) e('missing','folder',$imagefile_pth);
    }
    // Placeholder for missing image
    $noimage  = $pth['folder']['plugins'] . $plugin . '/images/empty100x30.gif';


    // check if language file exists and if it has the needed variables
    $languagefile = simpl_CheckLangFile();
    include($pth['folder']['plugins'].$plugin .'/languages/' . $sl . '.php');


    // return to the same scroll positions on reloading the page
    //===========================================================
    $scrolly = isset($_POST['scrolly'])?$_POST['scrolly']:'0';
    $scroll2 = isset($_POST['scroll2'])?$_POST['scroll2']:'0';
    //$o .= 'Scrollposition: '.$scrolly .'<br>';
    //$o .= 'Scrollposition: '.$scroll2 .'<br>';
    $bjs .= '<script type="text/javascript">window.scrollTo(0,'.$scrolly.');
             document.getElementById(\'imagelist\').scrollTop = '.$scroll2 .';';
    if(isset($_POST['scroll2'])) {
        $bjs .= 'document.getElementById(\'list_saved\').style.visibility = \'visible\';
                 setTimeout(function(){document.getElementById(\'list_saved\').style.visibility = \'hidden\'},1500);';
    }

    // load Java script for autogrowing text area input field
    //=========================================================
    $bjs .= '// the following code is adapted from Opera s Neil Jenkins, see
             // http://www.alistapart.com/articles/expanding-text-areas-made-elegant/
            function makeExpandingArea(container) {
                var area = container.querySelector("textarea");
                var span = container.querySelector("span");
                if (area.addEventListener) {
                    area.addEventListener("input", function() {
                        span.textContent = area.value;
                    }, false);
                    span.textContent = area.value;
                } else if (area.attachEvent) {
                    // IE8 compatibility
                    area.attachEvent("onpropertychange", function() {
                        span.innerText = area.value;
                    });
                    span.innerText = area.value;
                }
                // Enable extra CSS
                container.className += " active";
            }

            var areas = document.querySelectorAll(".expandingArea");
            var l = areas.length;

            while (l--) {
             makeExpandingArea(areas[l]);
            }
          // end of code for autoadjusting textareas
          </script>';


    // receive and save which Flexslider image file should be displayed, created, deleted, copied
    if ($action=='save_imagefile') {
        $o .= simpl_ImageFileAdmin();
        include($pth['folder']['plugins'].$plugin .'/languages/' . $sl . '.php');
        include($pth['folder']['plugins'].$plugin .'/config/config.php');
    }


    // Paths for imagebrowser (not for the flexslider image files)
    $imgdir    = $pth['folder']['images'];
    $image_pth = $plugin_cf[$plugin]['path_images'];

    // get directory changes of the image file browser
    if ($action=='chdir_images') {
        simpl_ChdirImages();
        include($pth['folder']['plugins'].$plugin .'/config/config.php');
        $image_pth = $plugin_cf[$plugin]['path_images'];
    }


    // write Java Scripts to $hjs
    simpl_JsSelectImage();


    // get the last "active" flexslider file from the plugin language file,
    // if language file has none, the standard flexslider file will be set as active
    $imagelist = $plugin_tx[$plugin]['temp_image_file']
          ? $plugin_tx[$plugin]['temp_image_file']
          : $plugin.'_'.$sl.'.php';
    simpl_MakeDefaultImgFile();


    // receive and save changes to the image list
    if($action=='save_images')  {
        simpl_SaveImages();
    }


    // read the flexslider image list into an array
    $imagearray = json_decode(file_get_contents($imagefile_pth.$imagelist),true);




    // standard admin mode, with image browser and flexslider image list. Start of HTML-body
    //======================================================================================
    if (!$admin || $admin=='plugin_main' && (!isset($_POST['preview']) || (isset($_POST['preview']) && !$_POST['preview']))) {


        // Selector (an manager) for Flexslider images list
        //==================================================
        $o .= simpl_FileManager();
        // Preview Link (has to be on the top because otherwise during preview the mouse cursor will be right
        // on the image and will prevent the sliding action, in case halt-onmouseover is set)
        $o .= '<button id="previewtop" OnClick="document.getElementById(\'preview\').value=true; document.getElementById(\'imagesform\').submit();">'
           .  $plugin_tx[$plugin]['preview']
           .  '</button>';


        // Title and License
        //====================
        $o .= '<h5>Flexslider_XH '.$plugin_cf['flexslider']['version']
           .  '<small><small> by <a href="http://svasti.de" target="_blank">svasti</a> &nbsp; '
           .  tag('input type="button" value="license?" style="font-size:80%;" OnClick="
              if(document.getElementById(\'license\').style.display == \'none\') {
                  document.getElementById(\'license\').style.display = \'inline\';
                  } else {
                  document.getElementById(\'license\').style.display = \'none\';
                  }
              "')
           . '</small></small></h5>' . "\n"
           . '<p id="license" style="display:none;">'
           . 'This plugin is free software under the terms of the GNU General Public License v. 3 or '
           . 'later, analog to <a href="' . $sn . '?' . uenc($cf['menu']['legal']) . '">'
           . $cf['menu']['legal'] . '</a>'. tag('br')
           . '<b>Acknowledgements:</b>'.tag('br')
           . 'This plugin uses jQuery/Flexslider version 2.2.2 by <a href="http://twitter.com/mbmufffin" target="_blank">Tyler Smith</a> '
           . 'distributed by <a href="http://www.woothemes.com/flexslider/" target="_blank">WooThemes</a>'. tag('br')
           . 'For Markdown to HTML the <a href="http://parsedown.org" target="_blank">Parsedown</a> parser by Emanuil Rusev is used.'
           . tag('br') . tag('br').'</p>'. "\n\n" ;


        // Easy update: check if updating/activation process should start or not
        //=======================================================================
        if(!isset($plugin_cf['flexslider']['version']) || version_compare($plugin_cf['flexslider']['version'],constant('FLEXSLIDER_VERSION'),'!=')) {

            $o .=  '<h1 style="border:2px red solid;background:yellow;text-align:center;">'
                .  'Plugin not activated'
                .  tag('br')
                . '<form action="" method="POST">'
                .  tag('input type="submit" style="font-weight:bold;padding:0 1em;letter-spacing:.05em;"
                   value="click here" name="activate" ')
                . '</form> '
                . 'to activate plugin'
                . '</h1>';
        } else {


            // Javascript image browser
            $o .= simpl_ImgBrowser();






            // Main Admin Area with display of chosen images, text and options
            //===================================================================================
            $o .= '<p id="list_saved">'.$plugin_tx['flexslider']['list_saved'].'</p>';
            $o .= '<form method="POST"
                   
                   id="imagesform" action="' . $sn
                .  '?&'.$plugin.'&amp;admin=plugin_main&amp;action=save_images">';

            // Image Editor, active only if called from an image of the flexslider image list
            $o .= simpl_ImgEdit();

            $o .=  "\n".tag('input type="submit"
                    onClick="document.getElementById(\'scrollpos\').value = document.documentElement.scrollTop;
                    document.getElementById(\'scrollpos2\').value = document.getElementById(\'imagelist\').scrollTop;"
                    value="'.ucfirst($tx['action']['save']).'"');
            $o .=  tag('input type="hidden" id="preview" name="preview"');
            $o .=  tag('input type="hidden" name="scrolly" id="scrollpos"');
            $o .=  tag('input type="hidden" name="scroll2" id="scrollpos2"');

            $o .= '<select name="addmore"
                  OnChange="document.getElementById(\'scrollpos\').value = document.documentElement.scrollTop;
                  document.getElementById(\'scrollpos2\').value = document.getElementById(\'imagelist\').scrollTop;
                  this.form.submit();">'
               .  "\n".'<option value="" selected>' . $plugin_tx[$plugin]['add_items'] . '?</option>';
            for ($i=1;$i<=20;$i++) {
                $o .= "\n".'<option value="'.$i.'">' . sprintf($plugin_tx[$plugin]['add_n_items'],$i) . '</option>';
            }
            $o .= '</select>';

            $o .= ' ('. count($imagearray['image1']). ' ' . $plugin_tx[$plugin]['items'] . ') ';

            // Options for display size
            $o .= ' &nbsp;<span class="nowrap">' . $plugin_tx[$plugin]['slider_size'] . ' ';
            $i = $imagearray['display'];
            $o .= '<select name="display[0]">'
               .  "\n".'<option value="standard"';
            $o .= $i=='standard'? 'selected':'';
            $o .= ' >standard</option>'
               .  "\n".'<option value="flexible"';
            $o .= $i=='flexible'? 'selected':'';
            $o .= ' >flexible</option>'
               .  "\n".'<option value="1.3333"';
            $o .= $i=='1.3333'? 'selected':'';
            $o .= ' >4:3</option>'
               .  "\n".'<option value="1.5"';
            $o .= $i=='1.5'? 'selected':'';
            $o .= ' >3:2</option>'
               .  "\n".'<option value="1.7777"';
            $o .= $i=='1.7777'? 'selected':'';
            $o .= ' >16:9</option>'
               .  "\n".'<option value="2"';
            $o .= $i=='2'? 'selected':'';
            $o .= ' >2:1</option>'
               .  "\n".'<option value="3"';
            $o .= $i=='3'? 'selected':'';
            $o .= ' >3:1</option>'
               .  "\n".'<option value="4"';
            $o .= $i=='4'? 'selected':'';
            $o .= ' >4:1</option>'
               .  "\n".'<option value="5"';
            $o .= $i=='5'? 'selected':'';
            $o .= ' >5:1</option>'
               .  "\n".'<option value="6"';
            $o .= $i=='6'? 'selected':'';
            $o .= ' >6:1</option>'
               . '</select></span>';

            // Options for animation
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['animation_type'] . ' ';
            $i = $imagearray['type'];
            $o .= '<select name="type[0]">'
               .  "\n".'<option value="slide"';
            $o .= $i=='slide'? 'selected':'';
            $o .= ' >slide</option>'
               .  "\n".'<option value="reverse"';
            $o .= $i=='reverse'? 'selected':'';
            $o .= ' >reverse</option>'
               .  "\n".'<option value="vertical"';
            $o .= $i=='vertical'? 'selected':'';
            $o .= ' >vertical</option>'
               .  "\n".'<option value="fade"';
            $o .= $i=='fade'? 'selected':'';
            $o .= ' >fade</option>'
               .  "\n".'<option value="static"';
            $o .= $i=='static'? 'selected':'';
            $o .= ' >static</option>'
               . '</select></span>';

            // Caption style options
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['caption_type'] . ' ';
            $i = $imagearray['caption'];
            $o .= '<select name="caption[0]">'
               .  "\n".'<option value="inverted"';
            $o .= $i=='inverted'? 'selected':'';
            $o .= ' >inverted</option>'
               .  "\n".'<option value="normal"';
            $o .= $i=='normal'? 'selected':'';
            $o .= ' >normal</option>'
               .  "\n".'<option value="overlay"';
            $o .= $i=='overlay'? 'selected':'';
            $o .= ' >overlay</option>'
               .  "\n".'<option value="overlay2"';
            $o .= $i=='overlay2'? 'selected':'';
            $o .= ' >overlay2</option>'
               . '</select></span>';

            // Start with random image?
            $checked = $imagearray['randomstart']? ' checked="checked"':'';
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['randomstart']
               .  tag('input type="hidden" value="0" name="randomstart[0]"')
               .  tag('input type="checkbox"'.$checked.' value="1" name="randomstart[0]"') . '</span>';

            // Image sequence: random or not
            $checked = $imagearray['random']? ' checked="checked"':'';
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['random']
               .  tag('input type="hidden" value="0" name="random[0]"')
               .  tag('input type="checkbox"'.$checked.' value="1" name="random[0]"') . '</span>';

            // Pause on mouse over?
            $checked = $imagearray['halt']? ' checked="checked"':'';
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['halt_on_mouseover']
               .  tag('input type="hidden" value="0" name="halt[0]"')
               .  tag('input type="checkbox"'.$checked.' value="1" name="halt[0]"') . '</span>';

            // Show direction navigation?
            $checked = $imagearray['dnav']? ' checked="checked"':'';
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['nav_direction']
               .  tag('input type="hidden" value="0" name="dnav[0]"')
               .  tag('input type="checkbox"'.$checked.' value="1" name="dnav[0]"') . '</span>';

            // Show dots under the slider as control navigation?
            $checked = $imagearray['cnav']? ' checked="checked"':'';
            $o .= ' <span class="nowrap">' . $plugin_tx[$plugin]['nav_control']
               .  tag('input type="hidden" value="0" name="cnav[0]"')
               .  tag('input type="checkbox"'.$checked.' value="1" name="cnav[0]"') . '</span>';

            // start table for entering image
            // =================================================================
            $height = $plugin_cf[$plugin]['admin_images_table_height']
                    ? ' style="max-height:'.$plugin_cf[$plugin]['admin_images_table_height'].';" '
                    : '';
            $o .= '<div id="imagelist"'.$height.'>'."\n".'<table id="imagelisttable">';

            foreach ($imagearray['image1'] as $key=>$value) {

              	$image1 =  $imagearray['image1'][$key];
                if($image1) {
                    $text =  preg_replace('/\<br(\s*)?\/?\>/i', PHP_EOL, $imagearray['text'][$key]);
                } else {
                    $text = $imagearray['markdown'][$key];
                }
                $link   =  $imagearray['link'][$key];
                list($width1, $height1) = $image1 ? getimagesize($imgdir.$image1) : array('0','0');

                $o .= "\n"
                        //1st row 1st td
                   .  '<tr>'
                   .  '<td class="image_admin">'

                   .  tag('input type="image" src="'.$pth['folder']['plugins']
                   .  $plugin.'/images/up.gif" style="width:15px;height:20px;" value="true" name="up['.$key.']"  alt="up" title="'
                   .  $plugin_tx['flexslider']['move_up']
                   .  '" onClick="document.getElementById(\'scrollpos\').value = document.documentElement.scrollTop;
                      document.getElementById(\'scrollpos2\').value = document.getElementById(\'imagelist\').scrollTop;"')

                   .  tag('br') . "\n"
                   .  tag('input type="image" src="'.$pth['folder']['plugins']
                   .  $plugin.'/images/delete.gif" style="width:15;height:15" value="true" name="delete['.$key.']" title="'
                   .  $plugin_tx['flexslider']['delete_item']
                   .  '" value=TRUE alt="Delete entry"
                      onClick="document.getElementById(\'scrollpos\').value = document.documentElement.scrollTop;
                      document.getElementById(\'scrollpos2\').value = document.getElementById(\'imagelist\').scrollTop;"')
                   .  "\n"

                   .  tag('br') . "\n"
                   .  tag('input type="image" src="'.$pth['folder']['plugins']
                   .  $plugin.'/images/add.gif" style="width:15;height:15" value="true" name="add['.$key.']" title="'
                   .  $plugin_tx['flexslider']['add_item']
                   .  '" value=TRUE alt="Add entry"
                      onClick="document.getElementById(\'scrollpos\').value = document.documentElement.scrollTop;
                      document.getElementById(\'scrollpos2\').value = document.getElementById(\'imagelist\').scrollTop;"')

                   .  "\n" . '</td><td>';

                $o .= '<table class="innertable">'
                   .  '<tr>'
                   .  '<td style="text-align:right">'.$plugin_tx[$plugin]['image_text'].':</td>'
                   .  "\n"
                   .  '<td>'
                   .  '<div class="expandingArea" ><pre><span></span>' . tag('br') . '</pre>'
                   .  '<textarea  name="text['.$key.']">'.$text.'</textarea></div>'
                   .  '</td>'
                   .  '</tr>'
                   .  "\n";

                $flex_marginline = $image1 ? ' style="display:none;"' :'' ;

                $o .= '<tr id="margin['.$key.']"'.$flex_marginline.'>'
                   .  "\n"
                   .  '<td style="text-align:right">'.$plugin_tx['flexslider']['text_only'].':</td>'
                   .  "\n"
                   .  '<td>margin-top '
                   .  tag('input type="text" style="width:2em;"  value="'.$imagearray['margintop'][$key].'" name="margintop['.$key.']"')
                   .  '%, margin-right/left '
                   .  tag('input type="text" style="width:2em;"  value="'.$imagearray['marginhorz'][$key].'" name="marginhorz['.$key.']"')
                   .  '%</td>'
                   .  '</tr>'
                   .  "\n";

               $o .=  '<tr>'
                   .  "\n"
                   .  '<td style="text-align:right">'.$plugin_tx[$plugin]['link'].':</td>'
                   .  "\n"
                   .  '<td>'
                   .  simpl_LinkSelect()
                   .  '</td>'
                   .  '</tr>'
                   .  "\n"

                   .  '<tr>'
                   .  '<td class="imagelist">';
                $o .= $image1
                   ?  tag('img src="'.$imgdir.$image1.'" id="dimage1['.$key.']" OnClick="addtotemp(\'image1['
                   .  $key.']\');document.getElementById(\'image1['.$key.']\').focus();"
                       OnDblclick="imgEdit(\''.$key.'\');" ')
                   :  tag('img src="'.$noimage.'" id="dimage1['.$key.']" OnClick="addtotemp(\'image1['
                   .  $key.']\');document.getElementById(\'image1['.$key.']\').focus();"
                      OnDblclick="imgEdit(\''.$key.'\');"');

                $o .= '</td>'
                   .  "\n"
                   .  '<td>'
                   .  tag('input type="text" readonly="readonly" class="imageinput" value="'.$image1.'" name="image1['.$key.']" id="image1['.$key
                   .  ']" OnDblclick="imgEdit(\''.$key.'\');" OnClick="addtotemp(\'image1['
                   .  $key.']\');document.getElementById(\'image1['.$key.']\').focus();"')
                   // delete
                   .  tag('img src="'.$pth['folder']['plugins']
                   .  $plugin.'/images/delete.gif" style="width:15;height:15" alt="Delete entry" title="'
                   .  $plugin_tx['flexslider']['remove_from_list']
                   .  '" onClick="document.getElementById(\'image1['
                   .  $key.']\').value = \'\';document.getElementById(\'margin['
                   .  $key.']\').style.display = \'table-row\';document.getElementById(\'image1['
                   .  $key.']\').focus();document.getElementById(\'d\'+\'image1['
                   .  $key.']\').src = \''.$noimage.'\';addtotemp(\'image1['
                   .  $key.']\');document.getElementById(\'dataimage1['
                   .  $key.']\').innerHTML=\' &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 0 kB &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; \';"')
                   .  "\n"
                   .  '<span id="dataimage1['.$key.']">';
                $o .=  $image1?  $width1.' x '.$height1.' px, '
                   .   simpl_aspectratio($width1,$height1)
                   .   round(filesize($imgdir.$image1) / 1024,1).' kB':'';
                $o .= '</span>'

                   //.  ' &nbsp; <button type="button" OnClick="imgEdit(\''.$key.'\');">'
                   //.   $plugin_tx['flexslider']['image_editing']
                   //.  '</button>'
                   .  '</td>'
                   .  '</tr>'
                   .  "\n";

                $o .= "\n</table>\n</td></tr>\n";
                $o .= "<tr>\n<td colspan='3' class='displayspacer'></td>\n</tr>\n";

            }

            $o .= "\n".'</table>'
               .  "\n".'</div>'
               .  "\n".tag('input type="submit"
                  onClick="document.getElementById(\'scrollpos\').value = document.documentElement.scrollTop;
                  document.getElementById(\'scrollpos2\').value = document.getElementById(\'imagelist\').scrollTop;"
                  value="'.ucfirst($tx['action']['save']).'"');

            $o .= tag('input type="submit"
                  OnClick="document.getElementById(\'preview\').value=true;" value="'
               .  ucfirst($tx['action']['save']) .' + ' .$plugin_tx[$plugin]['preview']
               .  '"');

            $o .=   "\n".'</form>'."\n";

        }

    } else if(isset($_POST['preview']) && $_POST['preview']) {

        simpl_SaveImages();
        $o .= tag('br') . flexslider($plugin_tx[$plugin]['temp_image_file']);

    } else {
        // rest of plugin menu
        $o .= plugin_admin_common($action, $admin, $plugin);
    }

}

?>
