<?php

/**
 * Front-end of Flexslider_XH.
 *
 * PHP version 5
 *
 * @category  CMSimple_XH
 * @author    svasti <svasti@svasti.de>
 * @copyright 2014 svasti <http://svasti.de>
 */

/*
 * Prevent direct access.
 */
if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

function flexslider($imagefile='')
{
    global $plugin_cf,$hjs,$pth,$sl;
    $o = $t = '';

    $imagefile = $imagefile
        ? strpos($imagefile,'.php')
        ? $imagefile
        : $imagefile.'.php'
        : 'flexslider_'.$sl.'.php';
    $filename = substr($imagefile,0,-4);

    $imagefile_pth = $plugin_cf['flexslider']['path_flexslider_data_files']
                   ? $plugin_cf['flexslider']['path_flexslider_data_files']
                   : $pth['folder']['userfiles'].'plugins/flexslider/';

    $i = json_decode(file_get_contents($imagefile_pth.$imagefile),true);
    $totalslides = count($i['image1']);

    $random      = isset($i['random']) && $i['random'] ? 'randomize: true,'."\n" : '';
    $randomstart = isset($i['randomstart']) && $i['randomstart'] ? 'startAt:'. mt_rand(0,$totalslides - 1) . ",\n" : '';
    $halt        = isset($i['halt']) && $i['halt'] ? 'pauseOnHover: true,'."\n" : '';
    $cnav        = isset($i['cnav']) && $i['cnav'] ?  '' : 'controlNav:false,'."\n";
    $dnav        = isset($i['dnav']) && $i['dnav'] ?  '' : 'directionNav:false,'."\n";
    $height      = isset($i['display']) && $i['display'] == 'flexible' ?  'smoothHeight: true,'."\n" : '';

    $extranav = $extranav1 = $extranav2 = '';
    $resume = $halt
            ? 'start: function(slider) {
slider.mouseout(function() {
slider.resume();
});
}' . "\n"
            : 'after: function(slider){
if (!slider.playing) {
                slider.play();
            }
}' . "\n";

    switch ($i['type']) {
        case 'vertical':
            $type = 'animation:"slide",'."\n".'direction: "vertical",'."\n";
        	break;
        case 'reverse':
            $type = 'animation:"slide",'."\n".'reverse:true,'."\n";
        	break;
        case 'static':
            $resume = '';
            $type = 'slideshow:false,'."\n".'animationSpeed:0,'."\n";
            if(!$dnav) {
                $extranav = '$(document).on(\'click\',\'.next\',function(){
                                $(\'.flex-direction-nav .flex-next:first\').trigger(\'click\');
                                return false;
                            });
                            $(document).on(\'click\',\'.prev\',function(){
                                $(\'.flex-direction-nav .flex-prev:first\').trigger(\'click\');
                                return false;
                            });';
                $extranav1 = 'controlsContainer: ".extradirnav",
                              after: function(slider) {
                                  $(".current-slide").text(slider.currentSlide + 1);
                              }';

                $extranav2 = '<div class="extradirnav">'
                           . '<a href="" class="prev">&#xf001; <span class="current-slide">1</span></a>/'
                           . '<a href="" class="next">'.$totalslides.' &#xf002;</a>'
                           . '</div>';
                $hjs .= '<style type="text/css">.flex-direction-nav {opacity:0;}.</style>';
            }
        	break;
        default:
            $type = 'animation:"'.$i['type'].'",'."\n";
        	break;
    }


    include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
    include_jQuery();
    include_jQueryPlugin('flexslider-min', $pth['folder']['plugins'].'flexslider/js/jquery.flexslider-min.js');

    $speed_slideshow = $plugin_cf['flexslider']['speed_slideshow'] 
                     ? 'slideshowSpeed: '.$plugin_cf['flexslider']['speed_slideshow'].",\n"
                     : '';
    $speed_animation = $plugin_cf['flexslider']['speed_animation'] 
                     ? 'animationSpeed: '.$plugin_cf['flexslider']['speed_animation'].",\n"
                     : '';

        $x = "\n" . '<script type="text/javascript">
$(window).load(function() {
$(\'.flexslider'.$filename.'\').flexslider({
initDelay: 0,' . "\n"
          . $randomstart
          . $speed_slideshow
          . $speed_animation
          . $halt
          . $random
          . $cnav
          . $dnav
          . $type
          . $height
          . 'prevText: "",' . "\n"
          . 'nextText: "",' . "\n"
          . $extranav1
          . $resume
        . '});' . "\n"
        . $extranav
    .'});
</script>';
    //$o .= nl2br(htmlspecialchars($x));

    if(isset($plugin_cf['flexslider']['used_in_template_or_newsbox'])) $o .= $x; else $hjs .= $x;

    foreach ($i['image1'] as $k=>$value) {

    	$t .= $halt? "\n" . '<li style="cursor:no-drop;">' : "\n<li>";
        if(isset($i['link'][$k]) && $i['link'][$k]) {
            $t .= strpos($i['link'][$k],'h')===0
                ? '<a href="'.$i['link'][$k].'" target="_blank">'
                : '<a href="'.$i['link'][$k].'">';
        } 
      	if(isset($i['image1'][$k]) && $i['image1'][$k]) {
            $width = isset($i['width'][$k])? 'style="width:'.$i['width'][$k].'%;margin:0 auto;"' : '';
            $t .= '<div style="width:100%;">';
            /*$t .= '<div style="position:absolute;margin-left:50%; border: 1px solid blue;">
                    <div style="padding:10%">
                  This is a preparation for Markdown formattet text on the right side of an image.
                  Could be implemented when needed. The size of the image would have to be recalculated
                  according to the desired size of the text.</div></div>';
            */
            $t .= tag('img '. $width .' src="' . $pth['folder']['images'].$i['image1'][$k] . '" alt="' . $i['image1'][$k] . '"');
            $t .= '</div>';
            if(isset($i['text'][$k]) && $i['text'][$k]) $t .= '<p class="flex-caption flex-'.$i['caption'].'">' . $i['text'][$k] . '</p>';
        } else {
            if(isset($i['text'][$k]) && $i['text'][$k]) {
                $t .= '<div class="flex-text" style="margin-top:'
                   . $i['margintop'][$k]
                   . '%; margin-right:'
                   . $i['marginhorz'][$k]
                   . '%; margin-left:'
                   . $i['marginhorz'][$k]
                   . '%;">' . $i['text'][$k] . '</div>';
            }
        }
        if(isset($i['link'][$k]) && $i['link'][$k]) $t .='</a>';
        $t .= '</li>';
    }

    // now the noscript part
    //=======================
    if(isset($i['image1'][0]) && $i['image1'][0]) {
        $width = isset($i['width'][0])
            ? ' style="width:'.$i['width'][0].'%;margin:0 0 0 '.((100-$i['width'][0])/2).'%;" '
            : ' style="max-width:100%;"';

        $noscript = '<noscript>'
            . tag('img '
            . $width
            . ' src="'
            . $pth['folder']['images'] . $i['image1'][0]
            . '" alt="' . $i['image1'][0]
            . '"')
            . '</noscript>';
    } else {
        $noscript = '<noscript>'
            . '<ul class="slides"><li><div class="flex-text" style="margin:'
            . $i['margintop'][0]
            . '% '
            . $i['marginhorz'][0]
            . '%;">'
            . $i['text'][0]
            . '</div></li></ul>'
            . '</noscript>';
    }


    $o .= "\n\n\n<!-- F L E X S L I D E R   S T A R T -->\n\n"
       .  '<div class="flexslider">'
       .  '<div class="flexslider'.$filename.'">'
       .  '<ul class="slides">'
       .  $t
       .  '</ul>'
       .  $noscript
       .  $extranav2
       .  '</div>'
       .  '</div>'
       .  "\n<!-- F L E X S L I D E R   E N D -->\n\n";


    return $o;
}

/**
 * function only for use of the plugin in a template, has to be called in the <head> area
 *
 */
function flexslider_init()
{
    global $pth,$plugin_cf;

    include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
    include_jQuery();
    include_jQueryPlugin('flexslider-min', $pth['folder']['plugins'].'flexslider/js/jquery.flexslider-min.js');

    $plugin_cf['flexslider']['used_in_template_or_newsbox'] = 'true';
}
?>